#ifndef WALLOBJECTS_HPP_INCLUDED
#define WALLOBJECTS_HPP_INCLUDED

#include "../../Game/Interactable/WallObject.hpp"
#include <functional>
#include <cstdint>
#include <vector>
#include <string>

/** @addtogroup Models
* @{ */
class WallObjects
{
    public:

        static std::vector<Interactable::WallObject> GetAll();
        static std::vector<Interactable::WallObject> GetAll(std::int32_t ID);
        static std::vector<Interactable::WallObject> GetAll(const std::string& Name);
        static std::vector<Interactable::WallObject> GetAll(const std::vector<std::int32_t>& IDs);
        static std::vector<Interactable::WallObject> GetAll(const std::vector<std::string>& Names);
        static std::vector<Interactable::WallObject> GetAll(const std::function<bool (const Interactable::WallObject&)>& Filter);

        static Interactable::WallObject Get();
        static Interactable::WallObject Get(const Tile& T);
        static Interactable::WallObject Get(std::int32_t ID);
        static Interactable::WallObject Get(const std::string& Name);
        static Interactable::WallObject Get(const std::vector<std::int32_t>& IDs);
        static Interactable::WallObject Get(const std::vector<std::string>& Names);
        static Interactable::WallObject Get(const std::function<bool (const Interactable::WallObject&)>& Filter);
};

/** @} */

#endif // WALLOBJECTS_HPP_INCLUDED
